package visnow.template1;

import pl.edu.icm.visnow.datasets.IrregularField;
import pl.edu.icm.visnow.datasets.RegularField;
import pl.edu.icm.visnow.engine.core.InputEgg;
import pl.edu.icm.visnow.engine.core.OutputEgg;
import pl.edu.icm.visnow.lib.templates.visualization.modules.OutFieldVisualizationModule;
import pl.edu.icm.visnow.lib.types.VNIrregularField;
import pl.edu.icm.visnow.lib.types.VNRegularField;
import pl.edu.icm.visnow.lib.utils.SwingInstancer;

public class ModuleTemplate extends OutFieldVisualizationModule {

    public static InputEgg[] inputEggs = null;
    public static OutputEgg[] outputEggs = null;

    public ModuleTemplate() {
        SwingInstancer.swingRunAndWait(new Runnable() {
            @Override
            public void run() {
                setPanel(ui);
            }
        });
    }
    
    @Override
    public void onActive() {
        //onActive() is executed when module starts
        
        // here do some processing when module is started externamlly or from network
        // creating output data outField based on settings in params and input data
        // e.g.
        //Field inField;
        //if(getInputFirstValue("inField") == null) {
        //    inField = ((VNField)getInputFirstValue("inField")).getField();  //get data from input port        
        //outField = do_something();                                         //do calculations        
        //if(outField instanceof RegularField) {
        //    outRegularField = (RegularField)outField;
        //    outIrregularField = null;
        //    setOutputValue("outRegularField", new VNRegularField(outRegularField));          //set regular output port value
        //    setOutputValue("outIrregularField", null);                                       //set ireeegular output port value
        //} else if(outField instanceof IrregularField) {
        //    outIrregularField = (IrregularField)outField;
        //    outRegularField = null;
        //    setOutputValue("outIrregularField", new VNIrregularField(outIrregularField));    //set ireeegular output port value
        //    setOutputValue("outRegularField", null);                
        //}
        prepareOutputGeometry();    //create default presentation of outField
        show();                     //and send it to output 
    }

}
